Findings
Create a finding
Create a finding. Regular human tokens and purposeless customer automation tokens may create drafts but cannot publish; platform-minted agent-run tokens, verified super-admins, and scoped pentesters may publish. Accepts optional sourceAgentName provenance for agent-authored drafts.
POST
/
api
/
v1
/
orgs
/
{orgSlug}
/
findings
Create a finding
curl --request POST \
--url https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
[
{
"title": "<string>",
"description": "<string>",
"resourceName": "<string>",
"resourceKey": "<string>",
"resourceType": "<string>",
"resourceArn": "<string>",
"targetUrl": "<string>",
"category": "<string>",
"tags": [],
"cwe": "<string>",
"sourceAgentName": "<string>",
"sourceName": "Tolmo",
"workflowRunId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"modusOperandi": "<string>",
"visibility": "published",
"status": "open"
}
]
'import requests
url = "https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings"
payload = [
{
"title": "<string>",
"description": "<string>",
"resourceName": "<string>",
"resourceKey": "<string>",
"resourceType": "<string>",
"resourceArn": "<string>",
"targetUrl": "<string>",
"category": "<string>",
"tags": [],
"cwe": "<string>",
"sourceAgentName": "<string>",
"sourceName": "Tolmo",
"workflowRunId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"modusOperandi": "<string>",
"visibility": "published",
"status": "open"
}
]
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify([
{
title: '<string>',
description: '<string>',
resourceName: '<string>',
resourceKey: '<string>',
resourceType: '<string>',
resourceArn: '<string>',
targetUrl: '<string>',
category: '<string>',
tags: [],
cwe: '<string>',
sourceAgentName: '<string>',
sourceName: 'Tolmo',
workflowRunId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
modusOperandi: '<string>',
visibility: 'published',
status: 'open'
}
])
};
fetch('https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
[
'title' => '<string>',
'description' => '<string>',
'resourceName' => '<string>',
'resourceKey' => '<string>',
'resourceType' => '<string>',
'resourceArn' => '<string>',
'targetUrl' => '<string>',
'category' => '<string>',
'tags' => [
],
'cwe' => '<string>',
'sourceAgentName' => '<string>',
'sourceName' => 'Tolmo',
'workflowRunId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'modusOperandi' => '<string>',
'visibility' => 'published',
'status' => 'open'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings"
payload := strings.NewReader("[\n {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"resourceName\": \"<string>\",\n \"resourceKey\": \"<string>\",\n \"resourceType\": \"<string>\",\n \"resourceArn\": \"<string>\",\n \"targetUrl\": \"<string>\",\n \"category\": \"<string>\",\n \"tags\": [],\n \"cwe\": \"<string>\",\n \"sourceAgentName\": \"<string>\",\n \"sourceName\": \"Tolmo\",\n \"workflowRunId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"modusOperandi\": \"<string>\",\n \"visibility\": \"published\",\n \"status\": \"open\"\n }\n]")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("[\n {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"resourceName\": \"<string>\",\n \"resourceKey\": \"<string>\",\n \"resourceType\": \"<string>\",\n \"resourceArn\": \"<string>\",\n \"targetUrl\": \"<string>\",\n \"category\": \"<string>\",\n \"tags\": [],\n \"cwe\": \"<string>\",\n \"sourceAgentName\": \"<string>\",\n \"sourceName\": \"Tolmo\",\n \"workflowRunId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"modusOperandi\": \"<string>\",\n \"visibility\": \"published\",\n \"status\": \"open\"\n }\n]")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"resourceName\": \"<string>\",\n \"resourceKey\": \"<string>\",\n \"resourceType\": \"<string>\",\n \"resourceArn\": \"<string>\",\n \"targetUrl\": \"<string>\",\n \"category\": \"<string>\",\n \"tags\": [],\n \"cwe\": \"<string>\",\n \"sourceAgentName\": \"<string>\",\n \"sourceName\": \"Tolmo\",\n \"workflowRunId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"modusOperandi\": \"<string>\",\n \"visibility\": \"published\",\n \"status\": \"open\"\n }\n]"
response = http.request(request)
puts response.read_body[
{
"id": "<string>",
"orgId": "<string>",
"agentId": "<string>",
"sourceAgentName": "<string>",
"isManual": true,
"shownVerbatim": true,
"severity": "<string>",
"title": "<string>",
"description": "<string>",
"resourceType": "<string>",
"resourceName": "<string>",
"resourceArn": "<string>",
"resourceKey": "<string>",
"targetUrl": "<string>",
"category": "<string>",
"tags": [
"<string>"
],
"cwe": "<string>",
"owasp": "<string>",
"status": "<string>",
"visibility": "<string>",
"taskIds": "<unknown>",
"tickets": [
{
"id": "<string>",
"provider": "<string>",
"integrationId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"accountAlias": "<string>",
"externalId": "<string>",
"identifier": "<string>",
"url": "<string>",
"createdAt": "<string>",
"syncStatus": "syncing",
"syncError": "<string>",
"syncedAt": "<string>"
}
],
"acknowledgedAt": "<string>",
"acknowledgedBy": "<string>",
"falsePositiveReason": "<string>",
"closedReason": "<string>",
"inReviewReason": "<string>",
"inReviewUrl": "<string>",
"sourceName": "<string>",
"origin": "<string>",
"ingestionStatus": "<string>",
"ingestedAt": "<string>",
"createdAt": "<string>",
"updatedAt": "<string>",
"attachmentCount": 4503599627370495,
"sourceSecret": {
"secretFindingId": "<string>",
"ruleId": "<string>",
"verificationState": "<string>",
"isActive": true,
"activeLastSeenAt": "<string>",
"lastValidatedAt": "<string>",
"validationMethod": "<string>"
},
"exploits": [
{
"id": "<string>",
"steps": [
"<string>"
],
"resultsAtExploitTime": "<string>",
"retestProbe": "<string>",
"oracle": "<string>",
"drivenBy": "<string>",
"createdAt": "<string>",
"exploitedAt": "<string>",
"lineageId": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
]{
"statusCode": 123,
"code": "<string>",
"error": "<string>",
"message": "<string>"
}Authorizations
A Tolmo API token, sent as Authorization: Bearer <token>. Either a user token (usr_tok.*, minted by tolmo auth login, scoped to your own permissions) or an org API token created in the Tolmo app, for CI and automation.
Path Parameters
Body
application/json
A single-line finding title of at most 120 characters, trimmed before storage and rejected rather than truncated when too long.
Required string length:
1 - 120Available options:
critical, high, medium, low, info Maximum string length:
512Maximum string length:
2048Maximum string length:
128Maximum string length:
2048Maximum string length:
2048Maximum string length:
48Maximum array length:
24Maximum string length:
48Maximum string length:
16Maximum string length:
128Maximum string length:
256Pattern:
^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$Available options:
draft, published Available options:
open, in_review, closed, acknowledged, false_positive, canceled Response
Default Response
Show child attributes
Show child attributes
Required range:
0 <= x <= 9007199254740991Show child attributes
Show child attributes
Show child attributes
Show child attributes
⌘I
Create a finding
curl --request POST \
--url https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
[
{
"title": "<string>",
"description": "<string>",
"resourceName": "<string>",
"resourceKey": "<string>",
"resourceType": "<string>",
"resourceArn": "<string>",
"targetUrl": "<string>",
"category": "<string>",
"tags": [],
"cwe": "<string>",
"sourceAgentName": "<string>",
"sourceName": "Tolmo",
"workflowRunId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"modusOperandi": "<string>",
"visibility": "published",
"status": "open"
}
]
'import requests
url = "https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings"
payload = [
{
"title": "<string>",
"description": "<string>",
"resourceName": "<string>",
"resourceKey": "<string>",
"resourceType": "<string>",
"resourceArn": "<string>",
"targetUrl": "<string>",
"category": "<string>",
"tags": [],
"cwe": "<string>",
"sourceAgentName": "<string>",
"sourceName": "Tolmo",
"workflowRunId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"modusOperandi": "<string>",
"visibility": "published",
"status": "open"
}
]
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify([
{
title: '<string>',
description: '<string>',
resourceName: '<string>',
resourceKey: '<string>',
resourceType: '<string>',
resourceArn: '<string>',
targetUrl: '<string>',
category: '<string>',
tags: [],
cwe: '<string>',
sourceAgentName: '<string>',
sourceName: 'Tolmo',
workflowRunId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
modusOperandi: '<string>',
visibility: 'published',
status: 'open'
}
])
};
fetch('https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
[
'title' => '<string>',
'description' => '<string>',
'resourceName' => '<string>',
'resourceKey' => '<string>',
'resourceType' => '<string>',
'resourceArn' => '<string>',
'targetUrl' => '<string>',
'category' => '<string>',
'tags' => [
],
'cwe' => '<string>',
'sourceAgentName' => '<string>',
'sourceName' => 'Tolmo',
'workflowRunId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'modusOperandi' => '<string>',
'visibility' => 'published',
'status' => 'open'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings"
payload := strings.NewReader("[\n {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"resourceName\": \"<string>\",\n \"resourceKey\": \"<string>\",\n \"resourceType\": \"<string>\",\n \"resourceArn\": \"<string>\",\n \"targetUrl\": \"<string>\",\n \"category\": \"<string>\",\n \"tags\": [],\n \"cwe\": \"<string>\",\n \"sourceAgentName\": \"<string>\",\n \"sourceName\": \"Tolmo\",\n \"workflowRunId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"modusOperandi\": \"<string>\",\n \"visibility\": \"published\",\n \"status\": \"open\"\n }\n]")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("[\n {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"resourceName\": \"<string>\",\n \"resourceKey\": \"<string>\",\n \"resourceType\": \"<string>\",\n \"resourceArn\": \"<string>\",\n \"targetUrl\": \"<string>\",\n \"category\": \"<string>\",\n \"tags\": [],\n \"cwe\": \"<string>\",\n \"sourceAgentName\": \"<string>\",\n \"sourceName\": \"Tolmo\",\n \"workflowRunId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"modusOperandi\": \"<string>\",\n \"visibility\": \"published\",\n \"status\": \"open\"\n }\n]")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.tolmo.com/api/v1/orgs/{orgSlug}/findings")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n {\n \"title\": \"<string>\",\n \"description\": \"<string>\",\n \"resourceName\": \"<string>\",\n \"resourceKey\": \"<string>\",\n \"resourceType\": \"<string>\",\n \"resourceArn\": \"<string>\",\n \"targetUrl\": \"<string>\",\n \"category\": \"<string>\",\n \"tags\": [],\n \"cwe\": \"<string>\",\n \"sourceAgentName\": \"<string>\",\n \"sourceName\": \"Tolmo\",\n \"workflowRunId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"modusOperandi\": \"<string>\",\n \"visibility\": \"published\",\n \"status\": \"open\"\n }\n]"
response = http.request(request)
puts response.read_body[
{
"id": "<string>",
"orgId": "<string>",
"agentId": "<string>",
"sourceAgentName": "<string>",
"isManual": true,
"shownVerbatim": true,
"severity": "<string>",
"title": "<string>",
"description": "<string>",
"resourceType": "<string>",
"resourceName": "<string>",
"resourceArn": "<string>",
"resourceKey": "<string>",
"targetUrl": "<string>",
"category": "<string>",
"tags": [
"<string>"
],
"cwe": "<string>",
"owasp": "<string>",
"status": "<string>",
"visibility": "<string>",
"taskIds": "<unknown>",
"tickets": [
{
"id": "<string>",
"provider": "<string>",
"integrationId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"accountAlias": "<string>",
"externalId": "<string>",
"identifier": "<string>",
"url": "<string>",
"createdAt": "<string>",
"syncStatus": "syncing",
"syncError": "<string>",
"syncedAt": "<string>"
}
],
"acknowledgedAt": "<string>",
"acknowledgedBy": "<string>",
"falsePositiveReason": "<string>",
"closedReason": "<string>",
"inReviewReason": "<string>",
"inReviewUrl": "<string>",
"sourceName": "<string>",
"origin": "<string>",
"ingestionStatus": "<string>",
"ingestedAt": "<string>",
"createdAt": "<string>",
"updatedAt": "<string>",
"attachmentCount": 4503599627370495,
"sourceSecret": {
"secretFindingId": "<string>",
"ruleId": "<string>",
"verificationState": "<string>",
"isActive": true,
"activeLastSeenAt": "<string>",
"lastValidatedAt": "<string>",
"validationMethod": "<string>"
},
"exploits": [
{
"id": "<string>",
"steps": [
"<string>"
],
"resultsAtExploitTime": "<string>",
"retestProbe": "<string>",
"oracle": "<string>",
"drivenBy": "<string>",
"createdAt": "<string>",
"exploitedAt": "<string>",
"lineageId": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
]{
"statusCode": 123,
"code": "<string>",
"error": "<string>",
"message": "<string>"
}